#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_swver.pl
#
# Version:  @(#)$Revision$
#
# Purpose:  
#
#   Specs: 
#
#  Author:  Bill Border
# !*-------------------------------------------------------------------------
$| = 1;
chop($CurrentDate = `date`);

$ProgName = "dbamon_swver";
$P = $ProgName;

use DBI;
require "cgi_handlers.pl";

$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# General parms required

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

#-----------------------------------------------------------------------------
#
# Subroutines
#
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
sub Include
#-----------------------------------------------------------------------------
{
    $file = $_[0];
    open (FILE, "$file") || die ("Can't open input file $file");
    while ($line = <FILE>) {
      chop( $line );
      print $line;
    }
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;

   #print "Content-type: text/html\n\n";
   #print "<head><title> Database Function Error - Output</title></head>";
   #print "<body>";

   print "</table><p>";
   print "<hr><h3> A Database Error Has Occured:</h3>";
   print "<h4>$errorMsg</h4>";
   print "SQL statement: <pre>$statement</pre>";
   print "Error: <pre>$DBI::errstr</pre>";


   Include("/opt/dbamon/htm/inc/foot_small.html");
   print "</body>";
   print "</html>";


   if ($entLocked) { close(ENTLOCKFILE); unlink($entlockfile); }
   if ($conLocked) { close(CONLOCKFILE); unlink($conlockfile); }
   if ($modLocked) { close(MODLOCKFILE); unlink($modlockfile); }
   if ($dbLocked)  { &unlockDb; }

   exit(1);
}

#-----------------------------------------------------------------------------
sub errorCheck
#-----------------------------------------------------------------------------
{
  foreach $item (sort keys %rqpairs)
  {
    #
    # Any variable name that ends with _ must be in the range of 1-5
    #
    $len     = length($item);
    $datalen = length($rqpairs{$item});
    $data    = $rqpairs{$item};
    ## print "item=$item data=$data\n";
  }

  for ($i=0; $i<=49; $i++)
  {
    $i_row = $i + 1;
    if ($rqpairs{"i_dbms_$i"} ne "") 
    {
      $found = 1;

      if ($rqpairs{"i_family_$i"} eq "") 
      {
	push (@error_list, "(Row $i_row) Software Version Family Cannot Be Blank If DBMS Is Specified\n");
      }

      if ($rqpairs{"i_minver_$i"} eq "") 
      {
	push (@error_list, "(Row $i_row) Software Minimum Version Cannot Be Blank If DBMS Is Specified\n");
      }

      if (length($rqpairs{"i_minver_$i"}) <= length($rqpairs{"i_family_$i"}))
      {
	push (@error_list, "(Row $i_row) The Length of the Minver Must Be > The Length of the Family\n");
      }

      if ($rqpairs{"i_minver_$i"} !~ /^$rqpairs{"i_family_$i"}/)
      {
	push (@error_list, "(Row $i_row) The Minver Must Begin With The Version Family\n");
      }

      $swver_dbms   = $rqpairs{"i_dbms_$i"};
      $swver_family = $rqpairs{"i_family_$i"};
      $swver_minver = $rqpairs{"i_minver_$i"};

      push(@insert_array, "insert into dbamon.swver (swver_dbms, swver_family, swver_minver) values ( \'$swver_dbms\', \'$swver_family\', \'$swver_minver\')");
    }
  }

  #if (!$found) 
  #{
  #  push (@error_list, "In order to save anything, you must specify at least 1 DBMS \n");
  #}
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   close(you_fill_in_the_file_descriptor);
   unlink($you_fill_in_the_tmp_file_name);
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str4=" <h3>Insufficient Or Missing Information...</h3><hr>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   print "<h4>Please correct the following:</h4>";
   print "<p>\n";
   print "<ul>\n";
   foreach( @error_list) 
   {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors correction(s) to make.<p>\n";
   }
   print "<hr>Click <b>BACK</b> and try again.\n";
      
}

#-----------------------------------------------------------------------------
sub buildForm 
#-----------------------------------------------------------------------------
{
  # Process monitor hours
  @hours = split(/\,/,$i_monitor_hours);
  ##print "hour=test num=$#hours;";
  foreach $hour (@hours)
  {
    $cmd = "\$i_monitor_hours_$hour = \"checked\"";
    ##print "hour=$hour cmd=$cmd";
    eval($cmd);
  }
  
  # Process monitor days
  @days = split(/\,/,$i_monitor_days);
  ##print "test num=$#days;";
  foreach $day (@days)
  {
    $cmd = "\$i_monitor_day_$day = \"checked\"";
    ##print "day=$day cmd=$cmd";
    eval($cmd);
  }
  
  print "<p><hr>
<FORM method='POST' action='/cgi-bin/dbamon_swver.pl?Submit'>
Modify fields and click 
<b><INPUT type=submit value=' Save Changes '></b>
here or at the bottom of this form. 
<p>
To Delete an entry, blank out the DBMS field.
<br>To Cancel, click <b>BACK</b>.
<HR>\n";

&msg("Selected $z pre-existing row(s)");

print"<p>
<table border=0 bgcolor=linen $style_normal>
<tr bgcolor=navyblue>
    <th $style_normal>DBMS
    <th $style_normal>Software<br>Version<br>Family
    <th $style_normal>Minimum<br>\"Good\" Version<br>For This Family
    <th $style_normal>Last Updated
</tr>";

#for ($i = 0; $i <= $selectcount; $i++)
for ($i = 0; $i <= 49; $i++)
{
  print "
   <tr bgcolor=wheat>
    <td $style_normal><select name=i_dbms_$i>
	  <option selected>$swver_dbms[$i]
	  <option>MSSQL
	  <option>Informix-UX
	  <option>OracleApps
	  <option>OracleDB-NT
	  <option>OracleDB-UX
	  <option>SAP
	  <option>
	  </select>
    <td $style_normal><b><INPUT type=text size=12 maxlength=12 name=i_family_$i value=$swver_family[$i]></b>
    <td $style_normal><b><INPUT type=text size=12 maxlength=12 name=i_minver_$i value=$swver_minver[$i]></b>
    <td $style_normal> <font size=2>$ts[$i] </font> \n";
}

print " </table> ";

  print " <HR>
<center><p><b>
<INPUT type=submit value=' Save Changes '>
</center></form></form>";
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error('Failed_on_DB_connect_in_updateDb');
}


#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  # Create the SQL SELECT statement
 
  if ($dbamon_repos eq "O") 
  {
    $statement  = "select 
      swver_dbms,
      swver_family,
      swver_minver,
      to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\')
    from dbamon.swver order by 1, 2, 3";
  }
  else
  {
    $statement  = "select 
      swver_dbms,
      swver_family,
      swver_minver,
      --to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\')
      dbamon.dateconvert_19(ts)
    from dbamon.swver order by 1, 2, 3";
  }

  ##print "statement=$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  ##print "<pre>\n";
  $selectcount = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    #
    # Assign var names
    #
    ( 
      $swver_dbms[$selectcount],
      $swver_family[$selectcount],
      $swver_minver[$selectcount],
      $ts[$selectcount]
      ) = @Data;
    ##print "parm=$parm value=$value\n";
    $cmd = "\$i_${parm}=\"${value}\"";
    $cmd =~ s/@/\\@/g;
    ##print "cmd=$cmd\n";
    eval($cmd); 
    $cmd = "\$i_${parm}_ts=\"${ts}\"";
    ##print "cmd=$cmd\n";
    eval($cmd); 
  }
  ##print "</pre>\n";
  $z = $selectcount + 1;

}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{
 print "<h1>Thank you for using this input form.</h1>";
 print "<h2>Your request has been sent.</h2>";
 print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
local($woid2check) = @_;
if (($woid2check =~ /\//) ||
    ($woid2check =~ /\;/) ||
    ($woid2check =~ /\</) ||
    ($woid2check =~ /\>/) ||
    ($woid2check =~ /\*/) ||
    ($woid2check =~ /\|/) ||
    ($woid2check =~ /\'/) ||
    ($woid2check =~ /\&/) ||
    ($woid2check =~ /\!/) ||
    ($woid2check =~ /\#/) ||
    ($woid2check =~ /\(/) ||
    ($woid2check =~ /\)/) ||
    ($woid2check =~ /\[/) ||
    ($woid2check =~ /\]/) ||
    ($woid2check =~ /\{/) ||
    ($woid2check =~ /\}/) ||
    ($woid2check =~ /\:/) ||
    ($woid2check =~ /\'/) ||
    ($woid2check =~ /\//) ||
    ($woid2check =~ /\n/) ||
    ($woid2check =~ /\"/))
      {
	print "Content-type: text/html\n\n";
	print "You have entered spurious control characters in a field.\n";
	print "You cannot use any of the following characters:\n";
	print " ;<>*|\'&!#()[]{}:\'/\"";
	print "\n The entry that is suspect is [$woid2check]\n";
	print "Please retry...\n";
	exit;
       }
}

#-----------------------------------------------------------------------------
sub deleteData
#-----------------------------------------------------------------------------
{
  &msg("Deleting Old Rows"); 
  $statement  = "delete from dbamon.swver";

  #print "statement=$statement\n";
  #system("id");

  $rc = $dbh->do($statement) || &error('Failed_on_DB_do_delete');
  &msg("Old Rows Deleted");
}

#-----------------------------------------------------------------------------
sub insertData
#-----------------------------------------------------------------------------
{
  # Read each variable and construct a SQL statement
  &msg("Inserting into DBAMON.SWVER"); 

  $insertcnt = 0;
 
  ##print "count=$#insert_array \n";
  foreach (@insert_array) 
  {
    $statement = $_;
    ##print "statement=$statement \n";
    $rc = $dbh->do($statement) || &error('Failed_on_DB_do_insert');
    $insertcnt++;
  }

  &msg("Inserted $insertcnt Updated Rows");
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

#---- Variables
$verb = @ARGV[0];

##system("echo '' | mailx -s '$P | $ENV{\"REMOTE_HOST\"} verb=$verb [AUTO]' border\@thecompany.com");

$SaveFile = "/tmp/$P.log";
unlink($SaveFile);
open(LOG, ">>$SaveFile" );
print LOG "$CurrentDate : \n";

&header("DBMS Software Version Oversight - Maintenance"); 

&get_request;
#
# When this pgm is invoked, it can be 1 of 2 ways:
# 1. With the KEY arg -> display confirm panel with this pgm as SUBMIT
# 2. With no arg (from submit) -> Delete row
#

#---- Connect to DB
&connectDB;

#---- 1. Display Form with current values

#---- Get form data

##print "verb=$verb\n";
if ($verb eq "")
{
  &msg("This transaction allows you to configure DBAmon to monitor the DBMS software 
    version to ensure that you are running <i>Known-Good</i> versions."); 
  &msg("For help on what <b>DBMS Software Version Oversight</b> is and how to configure it, see
    <a href='http://dbamon.com/config/swver.shtml'><b>DBMS Software Version Oversight</b></a>.");
  #---- Select existing data
  &selectData;

  #---- Build form
  &buildForm;
}

#---- 2. They clicked SUBMIT (Save Changes)

else
{

  #---- Save rqpairs to an easier name

  ##print "<pre>\n";
  foreach $item (sort keys %rqpairs)
  {
    @f{$item} = $rqpairs{$item};
    print LOG "$item = $rqpairs($item}\n";
    ##print "$item=$rqpairs{$item}\n" if $rqpairs{$item} ne "";
  }
  ##print "</pre>\n";

  #---- Check for errors

  &errorCheck;

  #---- If errors found, terminate

  if (@error_list != 0)
  {
    print LOG "Encountered errors\n";
    &error_html;
    exit 1;
  }

  #---- Delete old row

  &deleteData;

  #---- Insert new row

  &insertData;

  #print "<hr><p><b>Changes saved successfully.</b><p>Click <b>BACK</b> and <b>RELOAD</b> to view the updated list.  \n";
  &msg("Done"); 
  print "<hr><script language='JavaScript'> function back() { history.go(-2); }</script>\n";
  print "<a href='javascript:back()'><b>Click Here</a></b> to return to the DBAmon Console.";
}

#---- Make footer

Include("/opt/dbamon/htm/inc/foot_small.html");

#---- Go away
close(LOG);
exit 0;
